"""
ampcontrol is a basic python interface for communication with
multichannel amplifiers and recievers via the RS-232
communication port. This is a support file for the QT4 interface.

Copyright (C) 2009  Vidar Waagbo <vidar@waagbo.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.


TODO:

USAGE:

    Just add the following to the output from pyuic4:
        
    from ampcontrolQt4 import proxy
    self.proxy = proxy.Proxy(self)

"""

from PyQt4 import QtCore, QtGui
import xmlrpclib

class Proxy:

    def __init__(self, pyqt):
        self.pyqt = pyqt
        self.proxy = xmlrpclib.ServerProxy("http://10.0.0.65:8080/")
        self.secret = "SECRET"

        # START OF CONNECTION CRAP
        # THIS CRAP SHOULD BE MOVED TO connect.py AT SOME POINT!
        
        # Volume Control
        QtCore.QObject.connect(self.pyqt.sliderZone1, QtCore.SIGNAL("valueChanged(int)"), self.proxy.volume_zone1)
        QtCore.QObject.connect(self.pyqt.sliderZone2, QtCore.SIGNAL("valueChanged(int)"), self.proxy.volume_zone2)
        QtCore.QObject.connect(self.pyqt.sliderZone3, QtCore.SIGNAL("valueChanged(int)"), self.proxy.volume_zone3)
        QtCore.QObject.connect(self.pyqt.sliderZone4, QtCore.SIGNAL("valueChanged(int)"), self.proxy.volume_zone4)

        QtCore.QObject.connect(self.pyqt.muteZone1, QtCore.SIGNAL("toggled(bool)"), self.proxy.mute_zone1)
        QtCore.QObject.connect(self.pyqt.muteZone2, QtCore.SIGNAL("toggled(bool)"), self.proxy.mute_zone2)
        QtCore.QObject.connect(self.pyqt.muteZone3, QtCore.SIGNAL("toggled(bool)"), self.proxy.mute_zone3)
        QtCore.QObject.connect(self.pyqt.muteZone4, QtCore.SIGNAL("toggled(bool)"), self.proxy.mute_zone4)

        #Power Control
        QtCore.QObject.connect(self.pyqt.buttonPowerZone1, QtCore.SIGNAL("toggled(bool)"), self.proxy.power_zone1)
        QtCore.QObject.connect(self.pyqt.buttonPowerZone2, QtCore.SIGNAL("toggled(bool)"), self.proxy.power_zone2)
        QtCore.QObject.connect(self.pyqt.buttonPowerZone3, QtCore.SIGNAL("toggled(bool)"), self.proxy.power_zone3)
        QtCore.QObject.connect(self.pyqt.buttonPowerZone4, QtCore.SIGNAL("toggled(bool)"), self.proxy.power_zone4)
        QtCore.QObject.connect(self.pyqt.buttonForcePowerOff, QtCore.SIGNAL("toggled(bool)"), self.proxy.power_all_off)

        # END OF CONNECTION CRAP

    def power_zone1(self, value):
        if value:
            self.proxy.set_power(self.secret, True, 1)
        else:
            self.proxy.set_power(self.secret, False, 1)

    def power_zone2(self, value):
        if value:
            self.proxy.set_power(self.secret, True, 2)
        else:
            self.proxy.set_power(self.secret, False, 2)

    def power_zone3(self, value):
        if value:
            self.proxy.set_power(self.secret, True, 4)
        else:
            self.proxy.set_power(self.secret, False, 4)

    def power_zone4(self, value):
        if value:
            self.proxy.set_power(self.secret, True, 4)
        else:
            self.proxy.set_power(self.secret, False, 4)

    def power_all_off(self):
        self.proxy.complete_power_off(self.secret)
        
    def volume_zone1(self, value):
        self.proxy.set_volume(self.secret, value, 1)

    def volume_zone2(self, value):
        self.proxy.set_volume(self.secret, value, 2)

    def volume_zone3(self, value):
        self.proxy.set_volume(self.secret, value, 3)

    def volume_zone4(self, value):
        self.proxy.set_volume(self.secret, value, 4)

    def mute_zone1(self, value):
        if value:
            self.proxy.mute_on(self.secret, 1)
        else:
            self.proxy.mute_off(self.secret, 1)

    def mute_zone2(self, value):
        if value:
            self.proxy.mute_on(self.secret, 2)
        else:
            self.proxy.mute_off(self.secret, 2)

    def mute_zone3(self, value):
        if value:
            self.proxy.mute_on(self.secret, 3)
        else:
            self.proxy.mute_off(self.secret, 3)

    def mute_zone4(self, value):
        if value:
            self.proxy.mute_on(self.secret, 4)
        else:
            self.proxy.mute_off(self.secret, 4)
    
